Catcher catcher;   
Timer timer;   
Drop[] drops;       
int totalDrops = 0; 

boolean gameOver = false;
PImage img;

int score = 0;    
int level = 1;     
int lives = 10;    
int levelCounter = 0;

PFont f;

void setup() {
  size(400,400);
  smooth();
  catcher = new Catcher(32); 
  drops = new Drop[50]; 
  timer = new Timer(300);   
  timer.start();            
  f = createFont("Arial",12,true); 
}

void draw() {
  background(255);

  if (gameOver) {
    textFont(f,48);
    textAlign(CENTER);
    fill(0);
    text("GAME OVER",width/2,height/2);
    
  } 
  else {

     catcher.setLocation(mouseX,350); 

    catcher.display();


    if (timer.isFinished()) {

      if (totalDrops < drops.length) {
        drops[totalDrops] = new Drop();

        totalDrops++;
        
      }
      
      timer.start();
    }
    
    for (int i = 0; i < totalDrops; i++ ) {
      if (!drops[i].finished) {
        drops[i].move();
        drops[i].display();
        if (catcher.intersect(drops[i])) {
          drops[i].finished();
          levelCounter++;
          score++;
          gameOver = true; 
        }
        
      }
    }
  if(totalDrops >= 50)
      {
      textFont(f,48);
      textAlign(CENTER);
      fill(0);
      text("CLEAR",width/2,height/2);
      }
 }

}

class Catcher {
  float r;   // radius
  color col; // color
  float x,y; // location
  
  Catcher(float tempR) {
    r = tempR;
    col = color(50,10,10,150);
    x = 0;
    y = 0;
  }
  
  void setLocation(float tempX, float tempY) {
    x = tempX;
    y = tempY;
  }

  void display() {
    stroke(0);
    fill(col);
    ellipse(x,y,r,r);
  }
  

  boolean intersect(Drop d) {

    float distance = dist(x,y,d.x,d.y); 

    if (distance < r/2 + d.r) { 
      return true;
    } else {
      return false;
    }
  }
}


class Drop {
  float x,y;   
  float speed;
  color c;
  float r;  

  boolean finished = false;

  Drop() {
    r = 8;              
    x = random(width);     
    y = -r*4;            
    speed = random(2,5); 
    c = color(50,100,150); // Color
  }


  void move() {

    y += speed; 
  }

  boolean reachedBottom() {

    if (y > height + r*4) { 
      return true;
    } 
    else {
      return false;
    }
  }


  void display() {

    fill(c);
    noStroke();
    for (int i = 2; i < r; i++ ) {
      ellipse(x,y + i*4,i*2,i*2);
    }
  }


  void finished() {
    finished = true;
  }
}

class Timer {
 
  int savedTime; 
  int totalTime; 
  
  Timer(int tempTotalTime) {
    totalTime = tempTotalTime;
  }
  
  void setTime(int t) {
    totalTime = t;
  }
  
  void start() {

    savedTime = millis(); 
  }
  
  boolean isFinished() { 
    int passedTime = millis()- savedTime;
    if (passedTime > totalTime) {
      return true;
    } else {
      return false;
    }
  }
}



